"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initMiddleware = void 0;
const initMiddleware = (middleware) => {
    return (req, res) => new Promise((resolve, reject) => {
        middleware(req, res, (result) => {
            if (result instanceof Error) {
                console.error(result);
                return reject(result);
            }
            return resolve(result);
        });
    });
};
exports.initMiddleware = initMiddleware;
